Index: trunk/Poubelle/archTOI.old/starmatcher.cc
===================================================================
--- trunk/Poubelle/archTOI.old/starmatcher.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/starmatcher.cc	(revision 534)
@@ -0,0 +1,137 @@
+#include "starmatcher.h"
+#include "sststarfinder.h"
+#include "toimanager.h"
+#include "archexc.h"
+
+extern "C" {
+#include "aa_hadec.h"
+}
+
+#include <stdio.h>
+
+StarMatcher::StarMatcher() {
+  possibleTOIs.insert(TOI("dummatcher",      TOI::unspec, "", "blabla"));  
+  
+  FILE* f;
+  
+  f = fopen("gsc7.dat","r");
+  if (!f) throw ArchExc("Error opening gsc7.dat");
+  
+  fread(&nstars, sizeof(long), 1 , f);
+  stars = new gscStar[nstars];
+  fread(stars, sizeof(gscStar), nstars, f);
+  fclose(f);
+
+  TOIProducer* prod = TOIManager::findTOIProducer(TOI("sstStarCount"));
+  if (!prod) {
+    cerr << "StarMatcher : cannot find producer for sstStarCount" << endl;
+    exit(-1);
+  }
+  
+  SSTStarFinder* sprod = dynamic_cast<SSTStarFinder*>(prod);
+  if (!sprod) {
+    cerr << "StarMatcher : producer for sstStarCount is not a SSTStarFinder" << endl;
+    exit(-1);
+  }
+  
+  sprod->registerProcessor(this);
+
+}
+
+string StarMatcher::getName() {
+  return("StarMatcher 1.0");
+}
+
+static ofstream starstream("stars.dat");
+
+void StarMatcher::dataFeed(SSTEtoile const& x) {
+  lastStars[(long)x.TEchan] = x;
+}
+
+
+double StarMatcher::getValue(long sampleNum, TOI const& toi) {
+  if (lastStars.find(sampleNum) == lastStars.end()) return 0;
+  
+  SSTEtoile lastStar = lastStars[sampleNum];
+
+
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  double lat, lon, ts, alpha, delta, az;
+  
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    TOI inToi = (*i).first;
+    TOIProducer* prod =  (*i).second;
+    if (inToi.name == "latitude")  lat = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "longitude") lon = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "tsid")       ts = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "alphaFPC")  alpha = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "deltaFPC")  delta = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "azimuthFPC")   az = prod->getValue(sampleNum, inToi);
+  }
+    
+  // find all stars +- 2 deg boresight
+  double dist = 2;
+  double dmin = delta - dist; if (dmin<-90) dmin=-90;
+  double dmax = delta + dist; if (dmax> 90) dmax= 90;
+  double amin = alpha - dist / cos(delta * 3.1415926/180) / 15.;
+  if (amin<0) amin += 24;
+  double amax = alpha + dist / cos(delta * 3.1415926/180) / 15.;
+  if (amax>24) amax -= 24;
+  
+  int a,b,c;
+  a=0; c=nstars-1;
+  while (a+1<c) {
+    b = (a+c)/2;
+    if (stars[b].dec < dmin) a=b; else c=b;
+  }
+  int imin = a;
+  a=0; c=nstars;
+  while (a+1<c) {
+    b = (a+c)/2;
+    if (stars[b].dec < dmax) a=b; else c=b;
+  }
+  int imax = c;
+
+  for (int i=imin; i<=imax; i++) {
+    if (stars[i].ra >= amin && stars[i].ra <= amax) {
+      double ha = (ts/3600. - stars[i].ra) * 15. * 3.1415926/180.;
+      double elv, azim;
+      hadec_aa(lat * 3.1415926/180., ha, stars[i].dec * 3.1415926/180.,
+               &elv, &azim);
+      elv  *= 180/3.1415926;
+      azim *= 180/3.1415926;
+      if (azim<0) azim += 360;
+     
+      starstream << sampleNum << " " << 
+        /*lastStar.TEchan << " " <<*/ lastStar.NoDiode << " " <<
+        alpha << " " << delta << " " <<
+        az << " " << 
+        stars[i].ra << " " << stars[i].dec << " " <<
+        elv << " " << azim << "\n";
+    }
+  }
+  
+  return 1;
+}
+
+
+set<TOI> StarMatcher::reqTOIFor(TOI const&) {
+  set<TOI> t; 
+  t.insert(TOI("latitude",  TOI::unspec, "interp"));
+  t.insert(TOI("longitude", TOI::unspec, "interp"));
+  t.insert(TOI("tsid",      TOI::unspec));
+  t.insert(TOI("alphaFPC",  TOI::unspec, "galcross0"));
+  t.insert(TOI("deltaFPC",  TOI::unspec, "galcross0"));
+  t.insert(TOI("azimuthFPC",  TOI::unspec, "galcross0"));
+  return t;
+}
+
+void StarMatcher::propagateLowBound(TOI const& toi, long sampleNum) {
+  for (map<long,SSTEtoile>::iterator i = lastStars.begin(); i != lastStars.end(); i++)
+    if ((*i).first < sampleNum) lastStars.erase(i);
+}
+
+
+
+
+
Index: trunk/Poubelle/archTOI.old/starmatcher.h
===================================================================
--- trunk/Poubelle/archTOI.old/starmatcher.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/starmatcher.h	(revision 534)
@@ -0,0 +1,35 @@
+#ifndef STARMATCHER_H
+#define STARMATCHER_H
+
+
+#include "sststarfinder.h"
+#include "toipullproducer.h"
+
+class StarMatcher: public SSTStarProcessor, public TOIPullProducer {
+public:
+  StarMatcher();
+  
+  virtual void dataFeed(SSTEtoile const&); 
+
+  virtual string getName();
+  virtual double getValue(long sampleNum, TOI const& toi);
+
+protected:
+  virtual set<TOI>     reqTOIFor(TOI const&);
+  void  propagateLowBound(TOI const& toi, long sampleNum);
+#pragma options align=mac68k
+  struct gscStar {
+    float ra;
+    float dec;
+    short mag; // mag * 100
+  };
+#pragma options align=reset
+  
+  gscStar* stars;
+  long nstars;
+  
+  map<long,SSTEtoile> lastStars;
+};
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/templocator.cc
===================================================================
--- trunk/Poubelle/archTOI.old/templocator.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/templocator.cc	(revision 534)
@@ -7,4 +7,5 @@
 #include "fitsio.h"
 #include "plgalcross.h"
+#include "archparam.h"
 
 #ifndef M_PI
@@ -78,5 +79,4 @@
   
   // On trouve les croisements juste avant et juste apres notre sampleNum
-  int icross;
   for (icross=0; icross<nGalCross; icross++) {
     if (crossings[icross] > sampleNum) break;
@@ -98,5 +98,5 @@
   if (fabs(azCr2-220) < fabs(azCr1-220)) azCross = azCr2;
   
-  double rotSpeed = 360./(crossings[icross] - crossings[icross-1]); // °/sample
+  rotSpeed = 360./(crossings[icross] - crossings[icross-1]); // °/sample
   
   azimBolGC = azCross - (sampleNum - (crossings[icross-1]+12))*rotSpeed;
@@ -104,4 +104,18 @@
   if (azimBolGC > 360) azimBolGC -= 360;
 }
+
+double TempLocator::getRotSpeed(int sampleNum) {
+  findGeomFromGC(sampleNum);
+  return rotSpeed / archParam.acq.perEch;
+}
+
+int  TempLocator::getCrossSamples(int sampleNum, int& SN1, int& SN2) {
+  findGeomFromGC(sampleNum);
+  if (icross == 0 || icross >= nGalCross) return -1;
+  SN1 = crossings[icross-1];
+  SN2 = crossings[icross];
+  return 0;
+}
+
 
 void TempLocator::getAltAzBolo(int sampleNum, int ibolo, double& elv, double& az) {
@@ -166,4 +180,6 @@
   aa_hadec (lat * M_PI/180, elv * M_PI/180, az * M_PI/180, &ha, &dec);
   ra = - (ha * 180. / M_PI / 15) + (ts/3600.);
+  while (ra>24) ra -= 24;
+  while (ra<0) ra += 24;
   dec = dec * 180. / M_PI;
   return ra;
@@ -187,4 +203,12 @@
 double TempLocator::getDeltaCenter(int sampleNum) {
   return getDeltaBolo(sampleNum, 11);
+}
+
+double TempLocator::getAzimutCenter(int sampleNum) {
+  return getAzimutBolo(sampleNum, 11);
+}
+
+double TempLocator::getElvCenter(int sampleNum) {
+  return getElvBolo(sampleNum, 11);
 }
 
Index: trunk/Poubelle/archTOI.old/templocator.h
===================================================================
--- trunk/Poubelle/archTOI.old/templocator.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/templocator.h	(revision 534)
@@ -19,6 +19,10 @@
   double getAlphaBolo(int sampleNum, int ibolo);
   double getDeltaBolo(int sampleNum, int ibolo);
+  double getAzimutCenter(int sampleNum);
+  double getElvCenter(int sampleNum);
   double getAlphaCenter(int sampleNum);
   double getDeltaCenter(int sampleNum);
+  double getRotSpeed(int sampleNum); // deg/sec
+  int    getCrossSamples(int sampleNum, int& SN1, int& SN2);
   
   void getAltAzBolo(int sampleNum, int ibolo, double& elv, double& az);
@@ -36,4 +40,6 @@
   int xSampleNum; // pour le dernier calcul
   double azimBolGC;
+  double rotSpeed;
+  int icross;
   
   void findGeomFromGC(int sampleNum); // pour le bolo qui voit les xing
Index: trunk/Poubelle/archTOI.old/timetoiproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/timetoiproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/timetoiproducer.cc	(revision 534)
@@ -0,0 +1,73 @@
+// timetoiproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "timetoiproducer.h"
+#include "archparam.h"
+#include "archexc.h"
+#include "requesthandler.h"
+
+#define sn "sampleNum"
+#define mjd "MJD"
+#define utc "UTC"
+
+
+TimeTOIProducer::TimeTOIProducer()
+{
+  possibleTOIs.insert(TOI(sn,  TOI::unspec, "", "integer"));  
+  possibleTOIs.insert(TOI(mjd, TOI::unspec, "", "days"));
+  possibleTOIs.insert(TOI(utc, TOI::unspec, "", "hours"));
+}
+
+string TimeTOIProducer::getName() {
+  return("TimeTOIProducer 1.0");
+}
+
+
+
+long TimeTOIProducer::firstSampleNum(TOI const& toi) {
+  CHKPROD
+  return -99999999;
+}
+
+long TimeTOIProducer::lastSampleNum(TOI const& toi) {
+  CHKPROD
+  return  99999999;
+}
+
+bool TimeTOIProducer::canGetValue(long /*sampleNum*/, TOI const& toi) {
+  CHKPROD
+  return true;
+}
+
+bool TimeTOIProducer::canGetValueLater(long /*sampleNum*/, TOI const& toi) {
+  CHKPROD
+  return false; // we can always get value NOW
+}
+
+bool TimeTOIProducer::canGetPrevValue(long /*sampleNum*/, TOI const& toi) {
+  CHKPROD
+  return true;
+}
+ 
+bool TimeTOIProducer::canGetNextValue(long /*sampleNum*/, TOI const& toi) {
+  CHKPROD
+  return true;
+}
+
+double TimeTOIProducer::getValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  if (toi.name == sn) return sampleNum;
+  if (toi.name == mjd) return archParam.acq.SN2MJD(sampleNum);
+  if (toi.name == utc) return archParam.acq.SN2UTC(sampleNum);
+  throw ArchExc("TimeTOIProducer inconsistence " + toi.name);
+}
+
+double TimeTOIProducer::getPrevValue(long& sampleNum, TOI const& toi) {
+  sampleNum--;
+  return getValue(sampleNum, toi);
+}
+
+double TimeTOIProducer::getNextValue(long& sampleNum, TOI const& toi) {
+  sampleNum++;
+  return getValue(sampleNum, toi);
+}
Index: trunk/Poubelle/archTOI.old/timetoiproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/timetoiproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/timetoiproducer.h	(revision 534)
@@ -0,0 +1,33 @@
+// timetoiproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TIMETOIPRODUCER_H
+#define TIMETOIPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TimeTOIProducer : public TOIProducer {
+public:
+  TimeTOIProducer();
+
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual bool   canGetPrevValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetNextValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetValueLater(long sampleNum, TOI const& toi);  // Might, later but not now
+  
+  virtual double getPrevValue(long& sampleNum, TOI const& toi);
+  virtual double getNextValue(long& sampleNum, TOI const& toi);
+  virtual double getValue(long sampleNum, TOI const& toi);
+  
+  virtual long   firstSampleNum(TOI const&);
+  virtual long   lastSampleNum(TOI const&);
+  virtual string getName();
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toi.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toi.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toi.cc	(revision 534)
@@ -0,0 +1,74 @@
+// toi.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toi.h"
+#include "tokenizer.h"
+#include "archexc.h"
+
+vector<TOI> TOI::alltois;
+
+TOI::TOI(string n, int i, string opts, string u) 
+: name(n), index(i), unit(u)
+{
+  options = Tokenizer(opts).getTokenSet();
+  findref();
+}
+
+TOI::TOI(string n, int i, string opts, string u, string reqopts) 
+: name(n), index(i), unit(u)
+{
+  options = Tokenizer(opts).getTokenSet();
+  reqOptions = Tokenizer(reqopts).getTokenSet();
+  options.insert(reqOptions.begin(), reqOptions.end());
+  findref();
+}
+
+TOI::TOI(string n, int i, set<string> opts, string u) 
+: name(n), options(opts), index(i), unit(u)
+{
+  findref();
+}
+
+TOI::TOI(string s, string u) 
+: index(unspec), unit(u)
+{
+  vector<string> v = Tokenizer(s).getTokenVector();
+  if (v.empty()) throw ArchExc("TOI::TOI called with empty string");
+  vector<string>::iterator i = v.begin();
+  name = *i;
+  i++;
+  if (i == v.end()) return;
+  string& s1 = *i;
+  if (s1[0]>='0' && s1[0]<='9') {
+    index = atoi(s1.c_str());
+    i++;
+  }
+  options = set<string>(i, v.end());
+  findref();
+}
+
+void TOI::findref() {
+  for (vector<TOI>::iterator i = alltois.begin();
+       i != alltois.end(); i++) {
+    if ((*i).name == name && (*i).index == index && (*i).options == options) {
+       ref = (*i).ref;
+       return;
+    }
+  }
+  ref = alltois.size();
+  alltois.push_back(*this);
+}
+
+string TOI::fullName() {
+ string s = name;
+ if (index == all) { s += " all";}
+ else if (index != unspec) { 
+   char idx[20]; sprintf(idx, "%d", index);
+   s += string(" ")+idx;
+ }
+ for (set<string>::iterator i = options.begin(); i!=options.end(); i++) {
+   s += " " + *i;
+ }
+ if (unit != "") s += " (" + unit + ")";
+ return s;
+}
Index: trunk/Poubelle/archTOI.old/toi.h
===================================================================
--- trunk/Poubelle/archTOI.old/toi.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toi.h	(revision 534)
@@ -0,0 +1,49 @@
+// toi.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOI_H
+#define TOI_H
+
+#include<string>
+#include<set>
+#include<vector>
+using namespace std;
+
+struct TOI {
+  TOI() : name(""), index(unspec) {}
+  TOI(string n, int i, string opts="", string u="");
+  TOI(string n, int i, set<string> opts, string u="");
+  TOI(string, string u="");
+  TOI(string n, int i, string opts, string u, string reqopts);
+  
+  string name;
+  set<string> options;
+  set<string> reqOptions; // Used for possibleTOIs... Mandatory options for a producer.
+  int index;   // -1 : unspecified. -2 : all.
+  enum {unspec = -1, all = -2};
+  string unit;
+  inline bool operator == (TOI const&) const;
+  inline bool operator <  (TOI const&) const;
+  
+  int ref;
+  static vector<TOI> alltois;
+  void findref();
+  
+  string fullName();
+};
+
+bool TOI::operator == (TOI const& x) const {
+  return ref == x.ref;
+  //return (name == x.name && options == x.options && index == x.index);
+}
+
+bool TOI::operator < (TOI const& x) const {
+  return ref < x.ref;
+  #if 0
+  return ((name < x.name) ||
+          (name == x.name && options < x.options) ||
+          (name == x.name && options == x.options && index < x.index));
+  #endif
+}
+
+#endif
Index: trunk/Poubelle/archTOI.old/toiabsorber.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiabsorber.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiabsorber.cc	(revision 534)
@@ -0,0 +1,5 @@
+#include "toiabsorber.h"
+
+void TOIAbsorber::dataFeed(TOIProducer*, TOI const&, long, double)
+{}
+
Index: trunk/Poubelle/archTOI.old/toiabsorber.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiabsorber.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiabsorber.h	(revision 534)
@@ -0,0 +1,25 @@
+// toiabsorber.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOIABSORBER_H
+#define TOIABSORBER_H
+
+#include <set>
+#include <map>
+#include <deque>
+
+using namespace std;
+
+#include "toi.h"
+#include "ark.h"
+
+class TOIProducer;
+
+class TOIAbsorber {
+public:
+  virtual ~TOIAbsorber() {}
+  virtual void dataFeed(TOIProducer* source, TOI const& toi, long sampleNum, double value);
+};
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toiauxgpsproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiauxgpsproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiauxgpsproducer.cc	(revision 534)
@@ -0,0 +1,77 @@
+// toiauxgpsproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "toiauxgpsproducer.h"
+#include "archparam.h"
+#include "archexc.h"
+#include "requesthandler.h"
+
+#define latitude  "latitude"
+#define longitude "longitude"
+#define altitude  "altitude"
+
+
+TOIAuxGPSProducer::TOIAuxGPSProducer(AuxGPS* aux)
+: auxGPS(aux)
+{
+  possibleTOIs.insert(TOI(latitude,     TOI::unspec,   "auxGPS interp", "degrees"));  // + = NORTH
+  possibleTOIs.insert(TOI(longitude,    TOI::unspec,   "auxGPS interp", "degrees"));  // + = EAST
+  possibleTOIs.insert(TOI(altitude,     TOI::unspec,   "auxGPS interp", "meters"));  
+}
+
+string TOIAuxGPSProducer::getName() {
+  return("TOIAuxGPSProducer 1.0");
+}
+
+
+
+long TOIAuxGPSProducer::firstSampleNum(TOI const& toi) {
+  CHKPROD
+  return -99999999;
+}
+
+long TOIAuxGPSProducer::lastSampleNum(TOI const& toi) {
+  CHKPROD
+  return  99999999;
+}
+
+bool TOIAuxGPSProducer::canGetValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  return auxGPS->canGetLocation(archParam.acq.SN2MJD(sampleNum));
+}
+
+bool TOIAuxGPSProducer::canGetValueLater(long /*sampleNum*/, TOI const& toi) {
+  CHKPROD
+  return false; // we can always get value NOW
+}
+
+bool TOIAuxGPSProducer::canGetPrevValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  return canGetValue(sampleNum-1,  toi);
+}
+ 
+bool TOIAuxGPSProducer::canGetNextValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  return canGetValue(sampleNum+1,  toi);
+}
+
+double TOIAuxGPSProducer::getValue(long sampleNum, TOI const& toi) {
+  CHKPROD
+  double lat, lon, alt;
+  auxGPS->getLocation(archParam.acq.SN2MJD(sampleNum), lat, lon, alt);
+  if (toi.name == latitude)  return lat;
+  if (toi.name == longitude) return lon;
+  if (toi.name == altitude)  return alt;
+  throw ArchExc("TOIAuxGPSProducer inconsistence " + toi.name);
+}
+
+double TOIAuxGPSProducer::getPrevValue(long& sampleNum, TOI const& toi) {
+  sampleNum--;
+  return getValue(sampleNum, toi);
+}
+
+double TOIAuxGPSProducer::getNextValue(long& sampleNum, TOI const& toi) {
+  sampleNum++;
+  return getValue(sampleNum, toi);
+}
+
Index: trunk/Poubelle/archTOI.old/toiauxgpsproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiauxgpsproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiauxgpsproducer.h	(revision 534)
@@ -0,0 +1,37 @@
+// toiauxgpsproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOIAUXGPSPRODUCER_H
+#define TOIAUXGPSPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+#include "auxgps.h"
+
+
+class TOIAuxGPSProducer : public TOIProducer {
+public:
+  TOIAuxGPSProducer(AuxGPS* aux);
+
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual bool   canGetPrevValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetNextValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetValueLater(long sampleNum, TOI const& toi);  // Might, later but not now
+  
+  virtual double getPrevValue(long& sampleNum, TOI const& toi);
+  virtual double getNextValue(long& sampleNum, TOI const& toi);
+  virtual double getValue(long sampleNum, TOI const& toi);
+  
+  virtual long   firstSampleNum(TOI const&);
+  virtual long   lastSampleNum(TOI const&);  
+  virtual string getName();
+  
+protected:
+  AuxGPS* auxGPS;
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toiboloproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiboloproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiboloproducer.cc	(revision 534)
@@ -0,0 +1,52 @@
+// toiboloproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toiboloproducer.h"
+#include "archexc.h"
+#include "requesthandler.h"
+
+#define filt2 "boloMuV"
+
+
+TOIBoloProducer::TOIBoloProducer() {
+  possibleTOIs.insert(TOI(filt2, TOI::all, "", "microVolts"));  
+}
+
+string TOIBoloProducer::getName() {
+  return("TOIBoloProducer 1.0");
+}
+
+
+void TOIBoloProducer::dataFeed(TOIProducer* source, TOI const& toi, long sampleNum, double value) {
+  if (source->canGetValue(sampleNum-1, toi)) {
+    value = (value + source->getValue(sampleNum-1, toi))/2.;
+    TOI toi2 = toi;
+    toi2.name = filt2;
+    computedValue(toi2, sampleNum, value);
+  }
+}
+
+set<TOI> TOIBoloProducer::reqTOIFor(TOI const& toi) {
+  TOI toi2 = toi;
+  set<TOI> t; 
+  if (toi.name == filt2) {
+    toi2.name = "boloRawMuV";
+    t.insert(toi2);
+  } else {
+    throw ArchExc("Cannot produce "+toi.name);
+  }
+  return t;
+}
+
+
+void TOIBoloProducer::propagateLowBound(TOI const& toi, long sampleNum) {
+  CHKPROD
+  map<TOI, TOIProducer*> need = neededTOIs[toi];
+  int hlen = 1;
+  for (map<TOI, TOIProducer*>::iterator i = need.begin(); i != need.end(); i++) {
+    (*i).second->wontNeedEarlier((*i).first, this, sampleNum-hlen);
+  }
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/toiboloproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiboloproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiboloproducer.h	(revision 534)
@@ -0,0 +1,24 @@
+// toiboloproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOIBOLOPRODUCER_H
+#define TOIBOLOPRODUCER_H
+
+#include "toiderivproducer.h"
+#include "ark.h"
+
+
+class TOIBoloProducer : public TOIDerivProducer {
+public:
+  TOIBoloProducer();
+  virtual void dataFeed(TOIProducer* source, TOI const& toi, long sampleNum, double value);
+  virtual string getName();
+
+protected:
+  virtual set<TOI>     reqTOIFor(TOI const&);
+  virtual void         propagateLowBound(TOI const&, long sampleNum);
+};
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toiderivproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiderivproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiderivproducer.cc	(revision 534)
@@ -0,0 +1,123 @@
+// toiderivproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toiderivproducer.h"
+#include "toimanager.h"
+#include "archexc.h"
+#include "requesthandler.h"
+
+set<TOI> TOIDerivProducer::reqTOIFor(TOI const&) { 
+  set<TOI> empty;
+  return empty;
+}
+
+void TOIDerivProducer::outManifest(RequestHandler* h) {
+  outVersion(h);
+  h->processOption("#COMMENT", " Producing:");
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    h->processOption("#COMMENT", "  " + (*i).fullName());
+    set<TOI> x = reqTOIFor(*i);
+    if (!x.empty()) {
+      h->processOption("#COMMENT", "  from:");
+      for (set<TOI>::iterator j=x.begin(); j!=x.end(); j++) {
+        h->processOption("#COMMENT", "   " + (*j).fullName());
+      }
+    }
+  }
+}
+
+
+bool TOIDerivProducer::canProduce(TOI const& toi) {
+  // 1. Already in cache ?
+  map<TOI, map<TOI, TOIProducer*> >::const_iterator j = neededTOIs.find(toi);
+  if (j != neededTOIs.end()) return true;
+
+  // 2. It should be in our list of possibleTOI's
+  TOI myTOI;
+  for (set<TOI>::const_iterator i = possibleTOIs.begin(); i != possibleTOIs.end(); i++) {
+    if ((toi.name == (*i).name) &&
+        (toi.index == (*i).index || (*i).index == TOI::all)) {
+      myTOI = (*i); 
+      break;
+    }
+  }
+  if (myTOI.name == "") return false; // not in list
+  
+  // 3. Handle options
+  
+  set<string> extraopts = toi.options;
+  
+  // 3a should contain mandatory options
+  for (set<string>::iterator i = myTOI.reqOptions.begin(); 
+       i != myTOI.reqOptions.end(); i++) {
+    if (extraopts.find(*i) == extraopts.end()) return false;
+  }
+  
+  // 3b remove local options
+  
+  for (set<string>::iterator i = myTOI.options.begin();
+       i != myTOI.options.end(); i++) {
+    extraopts.erase(*i);   
+  }
+  
+  // 4. Find producers, distribute remaining options
+  map<TOI, TOIProducer*> fullInputTOI;
+  set<TOI> inputTOIs = reqTOIFor(toi);
+  for (set<TOI>::iterator i = inputTOIs.begin(); i != inputTOIs.end(); i++) {
+    TOI inTOI = *i;
+    TOIProducer* prod = TOIManager::findTOIProducer(inTOI);
+    if (!prod) return false;
+    if (!extraopts.empty()) {
+      set<string> xopts = prod->getAvailOptions(inTOI);
+      for (set<string>::iterator j = xopts.begin(); j != xopts.end(); j++) {
+        if (extraopts.find(*j) != extraopts.end()) {
+          inTOI.options.insert(*j);
+          extraopts.erase(*j);
+        }
+      }
+    }
+    fullInputTOI[inTOI] = prod;
+  }
+  
+  if (!extraopts.empty()) return false;
+  
+  neededTOIs[toi] = fullInputTOI;
+  return true;
+}
+
+set<string> TOIDerivProducer::getAvailOptions(TOI const& toi) {
+ // toi.options.clear();
+ // toi.index = -2;
+ // if (!canProduce(toi)) throw ArchExc("cannot produce " + toi.name);
+  set<string> s = getProperAvailOptions(toi);
+  map<TOI, TOIProducer*> need = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = need.begin(); i != need.end(); i++) {
+    set<string> s1 = (*i).second->getAvailOptions((*i).first);
+    s.insert(s1.begin(), s1.end());
+  }
+  return s;
+}
+
+void TOIDerivProducer::addTOI(TOI& toi, TOIAbsorber* client) {
+  TOIProducer::addTOI(toi, client);
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    TOI toi2 = (*i).first;
+    (*i).second->addTOI(toi2,this);
+  }
+}
+
+long TOIDerivProducer::wontNeedEarlier(TOI const& toi, TOIAbsorber* client, long t) {
+  long xt = TOIProducer::wontNeedEarlier(toi, client, t);
+  if (xt>0) propagateLowBound(toi, xt);
+  return xt;
+}
+
+// if no need for past values...
+void TOIDerivProducer::propagateLowBound(TOI const& toi, long sampleNum) {
+  CHKPROD
+  map<TOI, TOIProducer*> need = neededTOIs[toi];
+  for (map<TOI, TOIProducer*>::iterator i = need.begin(); i != need.end(); i++) {
+    (*i).second->wontNeedEarlier((*i).first, this, sampleNum);
+  }
+}
Index: trunk/Poubelle/archTOI.old/toiderivproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiderivproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toiderivproducer.h	(revision 534)
@@ -0,0 +1,27 @@
+// toiderivproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOIDERIVPRODUCER_H
+#define TOIDERIVPRODUCER_H
+
+#include "toiproducer.h"
+#include "toiabsorber.h"
+
+class TOIDerivProducer : public TOIProducer, public TOIAbsorber {
+public:
+
+  virtual bool         canProduce(TOI const&);
+  virtual void         addTOI(TOI&, TOIAbsorber* client);     // exception si pas productible
+  virtual set<string>  getAvailOptions(TOI const&);
+  virtual long         wontNeedEarlier(TOI const&, TOIAbsorber* client, long);
+  virtual void outManifest(RequestHandler*);
+
+protected:
+  mutable map<TOI, map<TOI, TOIProducer*> > neededTOIs; // TOI out, TOI in + associated producer, caching.
+
+  virtual set<TOI>     reqTOIFor(TOI const&);
+  virtual void         propagateLowBound(TOI const&, long sampleNum);
+};
+
+
+#endif
